% add path for labelme toolbox
LABELMETOOLBOXPATH = ['/csail/vision-torralba/people/jenny/' ...
                    'VideoLabelMe/toolboxLabelME']; %the path to
                                                    %the  labelme toolbox
                                                
addpath(LABELMETOOLBOXPATH);

% Define the root folder for the images
HOMEANNOTATIONS = 'http://labelme.csail.mit.edu/Annotations';
HOMEIMAGES = 'http://labelme.csail.mit.edu/Images';

IMAGESDESTINATION = 'Images'; %modify this path to where you want
                              %to put your images


longSize = 90;
Nimages = 500;   
testRatio = .10;
trainRatio = .9;
if(~exist('D','var'))
    D = LMdatabase(HOMEANNOTATIONS, {'05june05_static_street_porter'});
end

if(~exist(IMAGESDESTINATION, 'dir'))
    mkdir(IMAGESDESTINATION);
end

objectNames = { 'car'}%, 'bike', 'bottle', 'dog', 'face', 'lamp', 'balloon', 'lamp', 'couch'};
for i =1:length(objectNames),
    % download and upsample some car objects    
    [Dj,j] = LMquery(D, 'object.name', [objectNames{i} '-crop']);
    objects.database = Dj;
    objects.HOMEANNOTATIONS = HOMEANNOTATIONS;
    objects.HOMEIMAGES = HOMEIMAGES;
    
    save([IMAGESDESTINATION '/' objectNames{i} '.mat'], 'objects');   
    idxs = randperm(length(Dj));
    idxs = idxs(1:min(Nimages, length(Dj)));
    cutoff = floor(testRatio * min(Nimages, length(Dj)));
    testIdxs = idxs(1:cutoff); trainIdxs = idxs(cutoff + 1: end); 
    osr = LMdbCropObjects(Dj(trainIdxs), HOMEIMAGES, [IMAGESDESTINATION ...
                        '/' objectNames{i} '/train'], [objectNames{i} '_cropped'] , longSize);
    LMdbCropObjects(Dj(testIdxs), HOMEIMAGES, [IMAGESDESTINATION '/' ...
                        objectNames{i} '/test'], [objectNames{i} '_cropped'] , longSize);
    
    imageLongSize = round(longSize / osr);
    % download the full image with the object 
    LMdbWriteImages(Dj(trainIdxs), HOMEIMAGES, [IMAGESDESTINATION '/' objectNames{i} ...
                        '/train'], [objectNames{i} '_full'], imageLongSize)
    LMdbWriteImages(Dj(testIdxs), HOMEIMAGES, [IMAGESDESTINATION '/' objectNames{i} '/test'], ...
                    [objectNames{i} '_full'], imageLongSize);
     
    % download some noncars
    [Dk,j] = LMquery(D, 'object.name', ['-' objectNames{i} '-crop']);
    idxs = randperm(length(Dk));
    idxs = idxs(1:min(Nimages, length(Dk)));
    testIdxs = idxs(1:cutoff); trainIdxs = idxs(cutoff + 1: end); 

    LMdbWriteImages(Dk(trainIdxs), HOMEIMAGES, [IMAGESDESTINATION '/' objectNames{i} ...
                        '/train'], [objectNames{i} '_neg'], imageLongSize);
    LMdbWriteImages(Dk(testIdxs), HOMEIMAGES, [IMAGESDESTINATION '/' objectNames{i} '/test'] ...
                    , [objectNames{i} '_neg'], imageLongSize);
end
