function bb = fitBoundingBox(bb,threshold, imagesize)
%
% Extends the bounding boxes thathave the wrong aspect ratio.
%
% It might produce negativecoordinates.

bb = double(bb);

if nargin<2
    threshold = 2;
end

Dx = bb(2,:)-bb(1,:);
Dy = bb(4,:)-bb(3,:);
cx = (bb(2,:)+bb(1,:))/2;
cy = (bb(4,:)+bb(3,:))/2;
ratio = Dy./Dx;

j = find(ratio>threshold);
if length(j)>0
    Dx(j) = Dy(j)/threshold;
end

j = find(ratio<1/threshold);
if length(j)>0
    Dy(j) = Dx(j)*threshold;
end

bb(1,:) = cx - Dx/2;
bb(2,:) = cx + Dx/2;
bb(3,:) = cy - Dy/2;
bb(4,:) = cy + Dy/2;

bb = round(bb);

if nargin > 2
    nrows = imagesize(1);
    ncols = imagesize(2);
    bb(1,(bb(1,:)<1)) = 1;
    bb(3,(bb(3,:)<1)) = 1;
    bb(2,(bb(2,:)>ncols)) = ncols;
    bb(4,(bb(4,:)>nrows)) = nrows;
end

