#!/bin/sh
if [ $# -lt 4 ]
then
    echo "<usage>: runonimage.sh <image name/image directory/list file> "
    echo "          <out text file> <out image file/out image dir> <model path> <width> <height> <thresh>"
    echo "<example>: runonimage.sh car/test/car_full_test.lst  car_out.txt car/test/car_full_test car_hog 87 55 12"
    echo "<example>: runonimage.sh car/test/car_cropped_test.lst  car_out.txt car/test/car_full_test car_hog 87 55 12"
    echo "<example>: runonimage.sh bike/test/bike_full_test.lst  bike_out.txt bike/test/bike_full_test bike_hog 87 85 5"
    echo "<example>: runonimage.sh bike/test/bike_cropped_test.lst  bike_out.txt bike/test/bike_full_test bike_hog 87 85 5"
    echo
    echo "<example>: runonimage.sh bottle/test/bottle_full_test.lst  bottle_out.txt bottle/test/bottle_full_test bottle_hog 32 85 5"
    echo "<example>: runonimage.sh bottle/test/bottle_cropped_test.lst  bottle_out.txt bottle/test/bottle_full_test bottle_hog 32 85 5"
    echo
    echo "<example>: runonimage.sh dog/test/dog_full_test.lst  dog_out.txt dog/test/dog_full_test dog_hog 32 85 5"
    echo "<example>: runonimage.sh dog/test/dog_cropped_test.lst  dog_out.txt dog/test/dog_full_test dog_hog 32 85 5"
    echo
    echo "<example>: runonimage.sh lamp/test/lamp_full_test.lst  lamp_out.txt lamp/test/lamp_full_test lamp_hog 54 85 5"
    echo "<example>: runonimage.sh lamp/test/lamp_cropped_test.lst  lamp_out.txt lamp/test/lamp_full_test lamp_hog 54 85 5"
    echo
    echo "<example>: runonimage.sh couch/test/couch_full_test.lst  couch_out.txt couch/test/couch_full_test couch_hog 85 40 5"
    echo "<example>: runonimage.sh couch/test/couch_cropped_test.lst  couch_out.txt couch/test/couch_cropped_test couch_hog 85 40 5"
    echo
    echo "<example>: runonimage.sh car_side/test/car_side_full_test.lst  car_side_out.txt car_side/test/car_side_full_test car_side_hog 85 50 0.2"
    echo "<example>: runonimage.sh car_side/test/couch_cropped_test.lst  car_side_out.txt car_side/test/car_side_cropped_test car_sode_hog 85 50 0.2"




else
    InFile=$1
    OutFile=$2
    ImageFile=$3
    ModelPath=$4
    WIDTH=$5; export WIDTH
    HEIGHT=$6; export HEIGHT
    THRESH=$7

BinDIR=./bin
Classifier=classify_rhog

Option=" -W $WIDTH,$HEIGHT \
    -C 8,8 -N 2,2 -B 9 -G 8,8 -S 0 --wtscale 2 --maxvalue 0.2 --epsilon 1 \
    --fullcirc 0 -v 3 --proc rgb_sqrt --norm l2hys "

    ########
Margin=4
ExtraOption2=" -t $THRESH -m 0 "
ExtraOption1=" -p 1,0 --no_nonmax 0 -z 8,16,1.3 \
    --cachesize 128 --scaleratio 1.05 --winstride 8 \
    --margin $Margin,$Margin --avsize 0,96  "
ExtraOption=$ExtraOption1$ExtraOption2

echo Running hog on image list
echo $ModelPath

ResultDir=$OutFile
CMD="$Classifier  $Option  $ExtraOption \
    $InFile $OutFile $ModelPath/model_4BiSVMLight.alt -i $ImageFile "
$CMD 
fi
